unit EmbMask1;

{ *************************************************************** }
{  E-mail box address hide.                                       }
{  Generate full <a href... part with e-mail and reference text,  }
{  both randomly crypted with UTF-8 codes.                        }
{  Marian Stach, (C) 2003-07-07, Freeware                         }
{ *************************************************************** }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Edit3: TEdit;
    ComboBox1: TComboBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
  var EMStr, TEMStr, TStr1 : string;
      i, N : Integer;
begin
  Randomize;
  TEMStr := '';

  { Masking mailto part }
  EMStr := 'mailto';
  for i := 1 to Length (EMStr) do
      begin
        N := Random (TrackBar1.Max);
        case ComboBox4.ItemIndex of
             0 : TEMStr := TEMStr + EMStr [i];
             2 : TEMStr := TEMStr + '%' + IntToHex (Ord (EMStr [i]), 2)
             else if N < TrackBar1.Position
                     then TEMStr := TEMStr + '%' + IntToHex (Ord (EMStr [i]), 2)
                     else TEMStr := TEMStr + EMStr [i];
        end; { case }             
      end;  { for i }

  { Masking e-mail part }
  EMStr := ':' + Edit1.Text;
  for i := 1 to Length (EMStr) do
      begin
        N := Random (TrackBar1.Max);
        case EMStr [i] of
             '@' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + '@';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '%40'
                               else TEMStr := TEMStr + '@';
                        2 : TEMStr := TEMStr + '%40';
                    end;
             ':' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + ':';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '%3A'
                               else TEMStr := TEMStr + ':';
                        2 : TEMStr := TEMStr + '%3A';
                    end;
             '.' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + '.';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '%2E'
                               else TEMStr := TEMStr + '.';
                        2 : TEMStr := TEMStr + '%2E';
                    end
             else if N < TrackBar1.Position
                     then TEMStr := TEMStr + '%' + IntToHex (Ord (EMStr [i]), 2)
                     else TEMStr := TEMStr + EMStr [i]
        end; { case }
     end; { for i := }


  TEMStr := TEMStr + '">';
  { Masking link part }
  EMStr := Edit2.Text;
  for i := 1 to Length (EMStr) do
      begin
        N := Random (TrackBar1.Max);
        case EMStr [i] of
             '@' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + '@';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '&#64;'
                               else TEMStr := TEMStr + '@';
                        2 : TEMStr := TEMStr + '&#64;';
                    end;
             ':' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + ':';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '&#58;'
                               else TEMStr := TEMStr + ':';
                        2 : TEMStr := TEMStr + '&#58;';
                    end;
             '.' : case ComboBox1.ItemIndex of
                        0 : TEMStr := TEMStr + '.';
                        1 : if N < TrackBar1.Position
                               then TEMStr := TEMStr + '&#46;'
                               else TEMStr := TEMStr + '.';
                        2 : TEMStr := TEMStr + '&#46;';
                    end
             else if N < TrackBar1.Position
                     then begin
                            Str (Ord (EMStr [i]):1, TStr1);
                            TEMStr := TEMStr + '&#' + TStr1 + ';'
                          end
                     else TEMStr := TEMStr + EMStr [i]
        end; { case }
     end; { for i := }

  { Putting it together }
  Edit3.Text := '<a href ="' + TEMStr + '</a>';
  Button2.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit3.SelectAll;
  Edit3.CopyToClipboard;
end;

end.
